# pydeck: Beautiful maps with Python

*Get started and see interactive examples by clicking Launch Binder badge*

[![Binder](https://mybinder.org/badge_logo.svg)](https://mybinder.org/v2/gh/uber/deck.gl/binder?filepath=examples)

![demo](https://user-images.githubusercontent.com/2204757/58838976-1538f400-8615-11e9-84f6-a2fe42bb300b.gif)

Note that pydeck is under active development and not yet officially released. At the moment use of this library is experimental.

pydeck is a set of Python bindings for making spatial visualizations with [deck.gl](https://deck.gl),
optimized for a Jupyter Notebook environment.

## Installation

```bash
pip install -i https://test.pypi.org/simple/ pydeck
```

### Installation from source

```bash
# Clone the deck.gl repo
git clone https://github.com/uber/deck.gl/

# Navigate to the pydeck module
cd deck.gl/bindings/python/pydeck

# Create a virtual environment
python3 -m venv env3
. env3/bin/activate

python3 setup.py install
```

## Development

```
git clone https://github.com/uber/deck.gl/
cd deck.gl
# Build the entire deck.gl project
yarn bootstrap

# Optional but recommended: Run a hot reloading development server
cd modules/jupyter-widget
export PYDECK_DEV_SERVER=http://localhost:8080 && yarn watch
```

To specifiy a non-default URL for the webpack dev server, you can set a URL in the `PYDECK_DEV_SERVER` environment variable,
e.g., `export PYDECK_DEV_SERVER=http://localhost:8081`.

In a different terminal session, run:

```bash
cd deck.gl/bindings/python/pydeck

# Create a virtual environment
python3 -m venv env3
. env3/bin/activate

pip install -r requirements.txt
pip install -r requirements-dev.txt
pip install -e .
```

### Tests

Tests are handled by pytest. In this folder, you can type:

```bash
pytest
```

Tests expect the development build of pydeck.
You can click the URLs generated by the tests to see the visualizations generated by the tests.
